//+------------------------------------------------------------------+
//|                                            WhiteHorse Sto EA.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//+------------------------------------------------------------------+
extern bool trail = False;
extern double TrailingStop = 10;
extern int UpperLine   =80;
extern int LowerLine   =20;
extern int StoK        =5;
extern int StoD        =3;
extern int StoS        =3;
extern string MAMethods=" =0 is SMA,1 is EMA,2 is SMMA,3 is LWMA.";
extern int MAMethod    =0; // 0 is MAIN, and 1 is SIGNAL.
extern string pricefields=" =0 is Low/High, 1 is Close/Close.";
extern int pricefield  =0; // 0 is Low/High, 1 is Close/Close.
extern string MODEs    =" =0 is MAIN,1 is SIGNAL.";
extern int MODE        =0;
extern double SL       =100;
extern double TP       =100;
extern double Lots     =0.1;
extern int    MaxTrades   =1;

extern int magic = 2;

//+------------------------------------------------------------------+
int init()
  {
  
   if(TP < MarketInfo(Symbol(),MODE_STOPLEVEL) || SL < MarketInfo(Symbol(),MODE_STOPLEVEL) )
   {
      Alert("SL or TP are to low. The broker\'s minimum stoplevel is "+ MarketInfo(Symbol(),MODE_STOPLEVEL));
      return(-1);
   }
   
   if(Lots>MarketInfo(Symbol(),MODE_MAXLOT))
      Lots=MarketInfo(Symbol(),MODE_MAXLOT);
   if(Lots<MarketInfo(Symbol(),MODE_MINLOT))
      Lots=MarketInfo(Symbol(),MODE_MINLOT);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double Sto =iStochastic(Symbol(),0,StoK,StoD,StoS,MAMethod,pricefield,MODE,0);
   bool trade = true; // true if no open trade on this Pair exists with the same magic number

   int openOrders = OpenPositions(trade); 
                       
   if(openOrders<MaxTrades && Sto >= UpperLine && trade) {
      RefreshRates();
      OrderSend(Symbol(), OP_BUY,  Lots,  Ask,3,NormalizeDouble(MarketInfo(Symbol(),MODE_ASK)-SL*Point,Digits), NormalizeDouble(MarketInfo(Symbol(),MODE_ASK)+TP*Point,Digits), NULL, magic, 0, CLR_NONE);
     }
   if(openOrders<MaxTrades && Sto <= LowerLine && trade) {
      RefreshRates();
      OrderSend(Symbol(), OP_SELL,  Lots,  Bid,3,NormalizeDouble(MarketInfo(Symbol(),MODE_BID)+SL*Point,Digits), NormalizeDouble(MarketInfo(Symbol(),MODE_BID)-TP*Point,Digits), NULL, magic, 0, CLR_NONE);
     }

   return(0);
  }
  
 if (trail) trail(); 
//+------------------------------------------------------------------+


int OpenPositions(bool& trade){ // returns number of active positions.
   int trades=0;
   
   while(IsTradeContextBusy()) Sleep(50);

   for(int i = OrdersTotal()-1; i >= 0; i--) 
   {
      if( OrderSelect(i, SELECT_BY_POS) && OrderMagicNumber() == magic) 
      {  
         if (OrderSymbol() == Symbol()) trade = false;
         if (OrderType()==OP_BUY) trades++;
         if (OrderType()==OP_SELL)trades++;
      }  
   }
   return(trades);
}
void trail()
{
for (int i = 0; i < OrdersTotal(); i++) {
OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

if ( OrderSymbol()==Symbol() )
{
if (OrderType() == OP_BUY) {
if (Bid - OrderOpenPrice() > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
if (OrderStopLoss() < Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red);
}
}
} else if (OrderType() == OP_SELL) {
if (OrderOpenPrice() - Ask > TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) {
if ((OrderStopLoss() > Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT)) ||
(OrderStopLoss() == 0)) {
OrderModify(OrderTicket(), OrderOpenPrice(),
Ask + TrailingStop * MarketInfo(OrderSymbol(), MODE_POINT), OrderTakeProfit(), Red);
}
}
}
}
}
}